package com.fluentadflowreactnativesdk

import android.util.Log
import android.view.View
import com.facebook.react.bridge.ReadableArray
import com.facebook.react.bridge.ReadableMap
import com.facebook.react.uimanager.SimpleViewManager
import com.facebook.react.uimanager.ThemedReactContext
import com.facebook.react.uimanager.ViewManagerDelegate
import com.facebook.react.uimanager.annotations.ReactProp

class FluentAdFlowWidgetViewManager : SimpleViewManager<View>() {
  override fun getName() = "FluentAdFlowWidgetView"

  override fun createViewInstance(reactContext: ThemedReactContext): View {
    Log.d("FluentAdFlowWidgetView", "createViewInstance")
    return FluentAdFlowWidgetView(reactContext)
  }

  override fun getCommandsMap(): MutableMap<String, Int> {
    return mutableMapOf("setParams" to 1)
  }

  @ReactProp(name = "params")
  fun setParams(view: FluentAdFlowWidgetView, params: ReadableMap) {
    Log.d("FluentAdFlowWidgetViewManager", "setParams called with: $params")
    view.setParams(params)
  }

  @ReactProp(name = "wrapperName")
  fun setWrapperName(view: FluentAdFlowWidgetView, wrapperName: String) {
    view.setSdkWrapperName(wrapperName)
  }

  @ReactProp(name = "wrapperVersion")
  fun setWrapperVersion(view: FluentAdFlowWidgetView, wrapperVersion: String) {
    view.setSdkWrapperVersion(wrapperVersion)
  }

  @ReactProp(name = "isScrollingEnabled")
  fun setScrollingEnabled(view: FluentAdFlowWidgetView, isScrollingEnabled: Boolean) {
    view.setScrollingEnabled(isScrollingEnabled)
  }
}
