"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.FluentAdFlowWidgetView = void 0;
var _reactNative = require("react-native");
var _react = _interopRequireWildcard(require("react"));
var _version = require("../src/version");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const eventManagerEmitter = new _reactNative.NativeEventEmitter(_reactNative.NativeModules.AdsViewEventEmitter);
const {
  FluentAdFlowSdkManager
} = _reactNative.NativeModules;
class FluentAdFlowWidgetView extends _react.Component {
  widgetInstanceRef = /*#__PURE__*/_react.default.createRef();

  // Add missing class properties

  constructor(props) {
    super(props);
    this.state = {
      height: 0,
      viewId: Date.now() + '' + Math.floor(Math.random() * 1000000),
      // Unique viewId per instance
      isParamsSet: false
    };
  }

  // Set up event listeners inside componentDidMount
  componentDidMount() {
    this.subscriberOnAdFlowContainerClosed = eventManagerEmitter.addListener('onAdFlowContainerClosed', viewId => {
      // Check if the viewId matches before calling the callback
      if (String(viewId).trim() === String(this.state.viewId).trim()) {
        if (this.props.onAdShow) {
          this.props.onAdShow(false);
        }
        this.setState({
          height: 0
        });
        this.setState({
          isParamsSet: false
        });
      }
    });
    this.subscriberOnAdFlowContainerShow = eventManagerEmitter.addListener('onAdFlowContainerShow', viewId => {
      // Check if the viewId matches before calling the callback
      if (String(viewId).trim() === String(this.state.viewId).trim()) {
        if (this.props.onAdShow) {
          this.props.onAdShow(true);
        }
        this.setState({
          height: this.props.style?.height || 0
        });
      }
    });
    this.subscriberOnAdFlowContainerHeightChanged = eventManagerEmitter.addListener('onAdFlowContainerHeightChanged', result => {
      const resArry = result.split('$');
      if (resArry.length > 1) {
        const viewId = resArry[0];
        const height = resArry[1];
        if (String(viewId).trim() === String(this.state.viewId).trim()) {
          this.setState({
            height: parseFloat(height)
          });
        }
      }
    });
    this.subscriberOnError = eventManagerEmitter.addListener('onError', viewId => {
      if (String(viewId).trim() === String(this.state.viewId).trim()) {
        this.setState({
          height: 0
        });
        this.setState({
          isParamsSet: false
        });
      }
    });
    this.subscriberOnInternalAdShown = eventManagerEmitter.addListener('onInternalAdShown', viewId => {
      // Check if the viewId matches before calling the callback
      if (String(viewId).trim() === String(this.state.viewId).trim()) {
        if (this.props.onInternalAdLaunched) {
          this.props.onInternalAdLaunched(true);
        }
      }
    });
    this.subscriberOnInternalAdClosed = eventManagerEmitter.addListener('onInternalAdClosed', viewId => {
      // Check if the viewId matches before calling the callback
      if (String(viewId).trim() === String(this.state.viewId).trim()) {
        if (this.props.onInternalAdLaunched) {
          this.props.onInternalAdLaunched(false);
        }
      }
    });
  }

  // External method to set params
  setParams = params => {
    if (this.widgetInstanceRef) {
      const updatedParams = {
        ...params,
        viewId: this.state.viewId
      };
      const viewId = (0, _reactNative.findNodeHandle)(this.widgetInstanceRef.current);
      if (FluentAdFlowSdkManager && viewId) {
        FluentAdFlowSdkManager.setParams(viewId, updatedParams);
      }

      // Update state using setState
      this.setState({
        isParamsSet: true
      });
    }
  };

  // Properly remove event listeners in componentWillUnmount
  componentWillUnmount() {
    this.subscriberOnAdFlowContainerClosed?.remove();
    this.subscriberOnAdFlowContainerShow?.remove();
    this.subscriberOnAdFlowContainerHeightChanged?.remove();
    this.subscriberOnInternalAdShown?.remove();
    this.subscriberOnInternalAdClosed?.remove();
    this.subscriberOnError?.remove();
  }
  render() {
    return /*#__PURE__*/_react.default.createElement(WidgetNativeComponent, {
      ref: this.widgetInstanceRef,
      style: [this.props.style, {
        height: this.state.height
      }],
      wrapperName: _version.packageName,
      wrapperVersion: _version.packageVersion,
      isScrollingEnabled: this.props.isScrollingEnabled
    });
  }
}
exports.FluentAdFlowWidgetView = FluentAdFlowWidgetView;
const NativeAdView = (0, _reactNative.requireNativeComponent)('FluentAdFlowWidgetView');

// Forward the ref to the native component
const WidgetNativeComponent = /*#__PURE__*/(0, _react.forwardRef)((props, ref) => {
  return /*#__PURE__*/_react.default.createElement(NativeAdView, _extends({}, props, {
    ref: ref
  }));
});
var _default = FluentAdFlowWidgetView;
exports.default = _default;
//# sourceMappingURL=fluent-adflow-widget.js.map