"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FluentAdFlowWidget = void 0;
Object.defineProperty(exports, "FluentAdFlowWidgetView", {
  enumerable: true,
  get: function () {
    return _fluentAdflowWidget.FluentAdFlowWidgetView;
  }
});
var _reactNative = require("react-native");
var _fluentAdflowWidget = require("./fluent-adflow-widget");
var _DebugLogger = _interopRequireDefault(require("./DebugLogger"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// Safely access FluentAdFlowSdkManager
const FluentAdFlowSdkManager = _reactNative.NativeModules.FluentAdFlowSdkManager || {
  initSdk: () => {
    _DebugLogger.default.logMessage('The SDK Manager is not available.');
    return Promise.reject({
      errorCode: 4001,
      message: 'The SDK Manager is not available.'
    });
  }
};
class FluentAdFlowWidget {
  /**
   * Initialize the FluentAdFlow SDK.
   * @param {string} apiKey - API key for initialization.
   * @param {string} [referrer] - Optional referrer value.
   * @returns {Promise<void>}
   */
  static init(apiKey, referrer) {
    return new Promise((resolve, reject) => {
      // Use the version with success & failure callbacks
      FluentAdFlowSdkManager.initSdk(apiKey, referrer ?? '', () => resolve(),
      // Success callback
      (errorCode, message) => reject({
        errorCode,
        message
      }) // Reject with raw values
      );
    });
  }
}
exports.FluentAdFlowWidget = FluentAdFlowWidget;
//# sourceMappingURL=index.js.map