function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import { requireNativeComponent, NativeEventEmitter, NativeModules, findNodeHandle } from 'react-native';
import React, { Component, forwardRef } from 'react';
import { packageName, packageVersion } from '../src/version';
const eventManagerEmitter = new NativeEventEmitter(NativeModules.AdsViewEventEmitter);
const {
  FluentAdFlowSdkManager
} = NativeModules;
export class FluentAdFlowWidgetView extends Component {
  widgetInstanceRef = /*#__PURE__*/React.createRef();

  // Add missing class properties

  constructor(props) {
    super(props);
    this.state = {
      height: 0,
      viewId: Date.now() + '' + Math.floor(Math.random() * 1000000),
      // Unique viewId per instance
      isParamsSet: false
    };
  }

  // Set up event listeners inside componentDidMount
  componentDidMount() {
    this.subscriberOnAdFlowContainerClosed = eventManagerEmitter.addListener('onAdFlowContainerClosed', viewId => {
      // Check if the viewId matches before calling the callback
      if (String(viewId).trim() === String(this.state.viewId).trim()) {
        if (this.props.onAdShow) {
          this.props.onAdShow(false);
        }
        this.setState({
          height: 0
        });
        this.setState({
          isParamsSet: false
        });
      }
    });
    this.subscriberOnAdFlowContainerShow = eventManagerEmitter.addListener('onAdFlowContainerShow', viewId => {
      // Check if the viewId matches before calling the callback
      if (String(viewId).trim() === String(this.state.viewId).trim()) {
        if (this.props.onAdShow) {
          this.props.onAdShow(true);
        }
        this.setState({
          height: this.props.style?.height || 0
        });
      }
    });
    this.subscriberOnAdFlowContainerHeightChanged = eventManagerEmitter.addListener('onAdFlowContainerHeightChanged', result => {
      const resArry = result.split('$');
      if (resArry.length > 1) {
        const viewId = resArry[0];
        const height = resArry[1];
        if (String(viewId).trim() === String(this.state.viewId).trim()) {
          this.setState({
            height: parseFloat(height)
          });
        }
      }
    });
    this.subscriberOnError = eventManagerEmitter.addListener('onError', viewId => {
      if (String(viewId).trim() === String(this.state.viewId).trim()) {
        this.setState({
          height: 0
        });
        this.setState({
          isParamsSet: false
        });
      }
    });
    this.subscriberOnInternalAdShown = eventManagerEmitter.addListener('onInternalAdShown', viewId => {
      // Check if the viewId matches before calling the callback
      if (String(viewId).trim() === String(this.state.viewId).trim()) {
        if (this.props.onInternalAdLaunched) {
          this.props.onInternalAdLaunched(true);
        }
      }
    });
    this.subscriberOnInternalAdClosed = eventManagerEmitter.addListener('onInternalAdClosed', viewId => {
      // Check if the viewId matches before calling the callback
      if (String(viewId).trim() === String(this.state.viewId).trim()) {
        if (this.props.onInternalAdLaunched) {
          this.props.onInternalAdLaunched(false);
        }
      }
    });
  }

  // External method to set params
  setParams = params => {
    if (this.widgetInstanceRef) {
      const updatedParams = {
        ...params,
        viewId: this.state.viewId
      };
      const viewId = findNodeHandle(this.widgetInstanceRef.current);
      if (FluentAdFlowSdkManager && viewId) {
        FluentAdFlowSdkManager.setParams(viewId, updatedParams);
      }

      // Update state using setState
      this.setState({
        isParamsSet: true
      });
    }
  };

  // Properly remove event listeners in componentWillUnmount
  componentWillUnmount() {
    this.subscriberOnAdFlowContainerClosed?.remove();
    this.subscriberOnAdFlowContainerShow?.remove();
    this.subscriberOnAdFlowContainerHeightChanged?.remove();
    this.subscriberOnInternalAdShown?.remove();
    this.subscriberOnInternalAdClosed?.remove();
    this.subscriberOnError?.remove();
  }
  render() {
    return /*#__PURE__*/React.createElement(WidgetNativeComponent, {
      ref: this.widgetInstanceRef,
      style: [this.props.style, {
        height: this.state.height
      }],
      wrapperName: packageName,
      wrapperVersion: packageVersion,
      isScrollingEnabled: this.props.isScrollingEnabled
    });
  }
}
const NativeAdView = requireNativeComponent('FluentAdFlowWidgetView');

// Forward the ref to the native component
const WidgetNativeComponent = /*#__PURE__*/forwardRef((props, ref) => {
  return /*#__PURE__*/React.createElement(NativeAdView, _extends({}, props, {
    ref: ref
  }));
});
export default FluentAdFlowWidgetView;
//# sourceMappingURL=fluent-adflow-widget.js.map